#!/bin/sh

HOST=`uname -s`

LIBUSB_CFG=/opt/libusb-0.1.12/bin/libusb-config
LIBFTDI_CFG=/opt/libftdi-0.19/bin/libftdi-config

gcc -c term.c
gcc -c serial.c `$LIBUSB_CFG --cflags` `$LIBFTDI_CFG --cflags`
gcc -c sysutil.c
gcc -c x_vsprintf.c
gcc -c orx_unix_libftdi.c

if [ $HOST = "Darwin" ]
then
	gcc term.o serial.o sysutil.o x_vsprintf.o orx_unix_libftdi.o -o orx_unix_libftdi \
	`$LIBFTDI_CFG --prefix`/lib/libftdi.a `$LIBUSB_CFG --prefix`/lib/libusb.a \
	-Wl,-framework -Wl,IOKit -Wl,-framework -Wl,CoreFoundation -Wl,-prebind
else
	gcc term.o serial.o sysutil.o x_vsprintf.o orx_unix_libftdi.o -o orx_unix_libftdi \
	`$LIBFTDI_CFG --prefix`/lib/libftdi.a `$LIBUSB_CFG --prefix`/lib/libusb.a 
fi

