/*
 * Copyright (c) 2011, Noel Lemouel
 * All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>

static int fd;
static struct termios cfg0, cfg1;

int tio_init(char *tty)
{

	fd = open ( tty, O_RDWR | O_NOCTTY | O_NDELAY);

	if(fd == -1) {
		printf( "failed to open tty [%s]\n", tty);
	}

	if(!isatty(fd)) {
		printf("isatty error\n");
	}

	if(tcgetattr(fd, &cfg0) < 0) {
		printf("tcgetattr error\n");
	};

	if(tcgetattr(fd, &cfg1) < 0) {
		printf("tcgetattr error\n");
	};

	//cfg1.c_cc [VMIN] = 0 ;                /* min of 0 chars */
	//cfg1.c_cc [VTIME] = 1 ;               /* wait max vtime_val/10 sec (def 15/10) */

	/* input */
	// cfg1.c_iflag = IGNBRK | IGNPAR | ICRNL | IMAXBEL;
	/* local */
	cfg1.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);	/* raw input is unprocessed */
	/* output */
	// cfg1.c_oflag &= ~OPOST;

	tcsetattr( fd , TCSANOW , &cfg1 ) ; 

	return fd;
}

int io_read(unsigned char *c)
{
	return read(fd, c, 1);
}

int tio_getchar(void)
{
	int n;
   unsigned char c;

	while(1)
	{
		n = read(fd, &c, 1);

		if(n != -1){
			return(c);
		}else if(errno = EAGAIN){
			/* ... */
		}
		usleep(10000);
	}
}

int tio_putchar(unsigned char c)
{
	write(fd, &c, 1);
}

int tio_exit(void)
{
	tcsetattr( fd , TCSANOW , &cfg0 ) ; 

	return (close(fd));
}

